/*
    File:       PentiumCycleCount.h

    Function:	Cycle counting on intel pentium chips

    Author:     Andrew Willmott

    Copyright:  (c) 2000, Andrew Willmott
*/

#ifndef __PentiumCycleCount__
#define __PentiumCycleCount__

typedef struct PCC_Counter
{
	unsigned long int low;
	unsigned long int high;
} PCC_Counter;

void PCC_GetCounter(PCC_Counter *stamp)
{
  __asm__(".byte 0x0f,0x31" :
          "=a" (stamp->low),
          "=d" (stamp->high)
          );
}

inline unsigned int PCC_Elapsed(PCC_Counter start, PCC_Counter stop)
{
	if (stop.high == start.high)
		return(stop.low - start.low); 
	else
		return(start.low -((signed int)(stop.low)));
}

#endif