/*
    File:       FTRenderer.h

    Function:	

    Author:     Andrew Willmott

    Copyright:  (c) 1999-2000, Andrew Willmott
*/

#ifndef __FTRenderer__
#define __FTRenderer__

#include "gcl/Image.h"
#include <freetype.h>

class FTRenderer
{
public:
	FTRenderer();
	~FTRenderer();
	
	Void			RenderText(StrConst txt);
	Void			SetFace(StrConst filename);	
	Void			SetPointSize(Int size);

// internal
	Void			Init();
	Void			Free();
	Void			LoadGlyphs(StrConst txt, Int txtlen);
	Void 			RenderAllGlyphs(StrConst txt, Int txtlen);

	Void			SetupGlyphTable();	
	Void			FreeGlyphTable();	
	Void			FreeFace();

	Void 			RenderGlyph(TT_Glyph glyph,
								TT_F26Dot6 x_off, TT_F26Dot6 y_off,
                              	TT_Glyph_Metrics *gmetrics
                    	);

	Void			SetupImage(StrConst txt, Int txtlen);

	Int             dpi;
	Int             pointSize;
	Int             hinted;
	Int             smooth;
	Int             border;
	                
	TT_Engine       engine;
	TT_Face         face;
	Bool			faceSet;
	TT_Instance     instance;
	TT_Raster_Map   pixmap;
	                
	// Glyph table
	TT_Glyph        *glyphs;
	Int				numGlyphs;
	Bool			noCharMap;
	TT_CharMap  	charMap;

	Int             xShift, yShift;
	ByteImage       image;
};

#endif
