/*
	File:			Plot2D.h

	Function:		Defines a scene object which provides a 2D plot of a given
					function. Currently only over a rectangular domain.
					
	Author(s):		Andrew Willmott

	Copyright:		(c) 1995-2000, Andrew Willmott
 */

#ifndef __Plot2D__
#define __Plot2D__

#include "gcl/SceneObjects.h"

enum PlotType
{
	plotStep,			// sample in the middle of each cell
	plotSmoothed,		// sample in the middle of each cell, and interpolate
	plotVertex			// samples are at the vertices of cells
};

class scPlot2D : public scPrimitive
{
public:

	scPlot2D();

	Void		Draw(Renderer &r, SLContext *context);
	StrConst	Label() const;

	Object		*Clone() const { return new scPlot2D(*this); };

	GCLMat		samples;
	PlotType	plotType;
};


#endif

