/*
	File:			Renderer.cc

	Function:		Implements Renderer.h

	Author(s):		Andrew Willmott

	Copyright:		(c) 1995-2000, Andrew Willmott

*/

#include "gcl/Renderer.h"

Renderer::Renderer()
{
	bgColour = cBlack;
}

Renderer *Renderer::sCurrentRenderer = 0;

ostream &operator << (ostream &s, Renderer &gsr)
{
	gsr.Print(s);
	return(s);
}

Renderer &Renderer::Draw(Renderable &thing)
{
	thing.Draw(SELF);
	return(SELF);
}

Renderer &Renderer::Draw(Renderable *thing)
{
	if (thing)
		thing->Draw(SELF);
	return(SELF);
}

Renderer &Renderer::SetColour(const Colour4 &c)
{
	return(SetColour((Colour&)c));
}

Renderer &Renderer::SetTexCoord(const Coord &c)
{
	return(SELF);
}

Renderer &Renderer::SetTexture(const Image *image)
{
	return(SELF);
}

