# Standard cube with white walls that both emit and reflect. The radiosity solution
# for this should converge to a cube with walls having the same radiosity everywhere.

# Most interesting things to do is see how poorly progressive radiosity does with 
# this compared to matrix radiosity, and how adjusting the formfactor approximation
# (by dropping dF to 0.01 so area FF gets used most of the time) affects the quality
# of the solution. If your form-factor approximation is bad, this scene will show it.

object "cube"

    avar emittance wall_emittance [0 0.15 1] [1 1 1]
	avar colour wall_reflectance [0 0.7 1] [1 1 1]

#   bottom front left, bfr, brr, brl, tfl, tfr, trr, trl
    points [[-1 -1 1] [1 -1 1] [1 -1 -1] [-1 -1 -1]
            [-1  1 1] [1  1 1] [1  1 -1] [-1  1 -1]]

    indexes [0 1 2 3]
    poly
    indexes [7 6 5 4]
    poly
    indexes [2 1 5 6]
    poly
    indexes [0 3 7 4]
    poly
    indexes [1 0 4 5]
    poly
    indexes [3 2 6 7]
    poly
end
