/*
	File:			AnaMesh.cc

	Function:		See header file

	Author(s):		Andrew Willmott

	Copyright:		(c) 1997-2000, Andrew Willmott

*/

#include "AnaMesh.h"
#include "AnaRad.h"

Colour AnaGrid::Sample(Coord c)
// calculate radiosity using PatchFactor directly
{
	Int		i, j;
	Colour	patchCol;
	GCLReal	s = c[0];
	GCLReal	t = c[1];		
	AnaRad	*rad = (AnaRad*) gRadControl->radObject;

	Point	p = Vertex(1) + s * (Vertex(2) - Vertex(1)) 
		+ t * (Vertex(0) - Vertex(1));

	patchCol = cBlack;
		
	for (j = 0; j < rad->lights.NumItems(); j++)	
		patchCol += rad->lights[j]->Emittance()
			* rad->lights[j]->PatchFactor(p, Normal());
		
	patchCol *= Reflectance();
	patchCol += Emittance();
	
	return(patchCol);
}
