/*
	File:			AnaRad.h

	Function:		Calculates direct illumination using analytic
					area-to-point form factors. Also calculates scene
					statistics such as Discrete scene visibility mutual
					information (DSVMI).

	Author(s):		Andrew Willmott

	Copyright:		(c) 1999-2000, Andrew Willmott
 */

#ifndef __AnaRad__
#define __AnaRad__

#include "RadMethod.h"

class AnaRad : public RadMethod
{
public:
	
	Bool		Render();			// override
	Int			Stage(Int stage);	// override
	Void		DumpStats();

	RadElem		*NewMesh();

	static Void	*New() { return(new AnaRad); };

	PatchList	lights;
	GCLReal		theMI;
};

#endif
