/*
	File:		RadPane.h

	Function:	Display panes for radiosity mesh

	Author:		Andrew Willmott

    Copyright:  (c) 1996-2000, Andrew Willmott
*/

#ifndef __RadPane__
#define __RadPane__

#include "RadMethod.h"

#include "gcl/ScenePane.h"
#include "gcl/Forms.h"


FL_OBJECT 	*const msgPick = (FL_OBJECT *) 0x04;

class FormsScenePane : public ScenePane
{
public:
				FormsScenePane(Bool doubleBuf) : ScenePane(doubleBuf) {};

	Void		SetParent(Form *parent);
	
	Form		*parent;
};

class HRElem;

class RadScenePane : public FormsScenePane
{
public:
				RadScenePane(Bool doubleBuf = true);

	Void        SetScene(scScenePtr scene);
	            
	Void        StartDrag(Coord c, Int modifiers);
	Void        EndDrag(Coord c, Int modifiers);
	Void        Drag(Coord c, Int modifiers);
	Void        SelectDrag();
	Void        Redraw();
	            
	RadMethod   *mesh;
	RadElem     *selPatch[2];
	HRElem      *selElem[2];
	Transform   inverseTransform;

	Bool		enabled;
};

#endif
