/*
	File:			RadScene.cc

	Function:		See header file

	Author(s):		Andrew Willmott

	Copyright:		(c) 1997-2000, Andrew Willmott

*/

#include "RadScene.h"
#include "RadMethod.h"

// --- scRadMesh class ----------------------------------------------------------


Void scRadMesh::Draw(Renderer &r, SLContext *context)
{
	rad->Draw(r);
}

#ifdef OLD
Void scRadMesh::Compare(scPrimitive *to, GCLReal edgeLen, CompareStats &stats)
{
	Int			i;
	RadMethod	*other = ((scRadMesh*) RadCast(to))->rad;
	// should check that 'to' is another mesh...
		
	Assert(rad->baseElems.NumItems() == other->baseElems.NumItems(),
		"(scRadMesh::Compare) mesh mismatch");
		
	for (i = 0; i < rad->baseElems.NumItems(); i++)
		rad->baseElems[i]->Compare(other->baseElems[i], edgeLen, stats);
}
#endif

Void scRadMesh::Parse(istream &s)
{
	String	str;

	str.ReadWord(s);
		
	delete rad;
	rad = 0;
	// XXX get register working or redo!!!

	if (rad)
		rad->Parse(s);
	else
	{
		cerr << "*** mesh: unknown algorithm type: " << str << endl;

		do
		{
			str.ReadLine(s);
			str.ReadWord(s);
		}
		while (str != "end");
	}
}

Void scRadMesh::Print(ostream &s) const
{
	Int	i;
	s << "mesh ";

	if (rad)
		rad->Print(s);
	else
		s << "null";
	s << endl << "end";
}


// --- Matrix display pane ----------------------------------------------------


StrConst scMatrixDisplay::Label() const
{
	return("Matrix Display");
}

#define MAT_OUTLINE

Void scMatrixDisplay::Draw(Renderer &r, SLContext *context)
{
#ifdef MAT_OUTLINE
	r
		.C(cWhite)
		.Begin(renLineLoop)
		.P(Point(-1, -1, 0))
		.P(Point(1, -1, 0))
		.P(Point(1, 1, 0))
		.P(Point(-1, 1, 0))
		.End();
#endif
	if (method && *method)
		((RadMethod *)(*method))->DrawMatrix(r);
	else
		_Error("no rad method set.");
}
