/*
	File:		VecLink.h

	Function:	A wavelet radiosity link that implements vector-based
	            transfer.

	Author:		Andrew Willmott

    Copyright:  (c) 1997-2000, Andrew Willmott
*/

#ifndef __VecLink__
#define __VecLink__

#include "HRLink.h"

class VecLink : public HRLink
{
public:
	HRLink			*New() { return new VecLink; };

	HRElem			*To()	{ return((HRElem*) to); };
	HRElem			*From()	{ return((HRElem*) from); };

	RefChoice		RefineOracle();

	Void			Gather();
	Bool			CalcTransport();
	Bool			CalcVisibility(HRLink *parent, Bool rv);
	GCLReal			Error();
	GCLReal			BFAError();

	GCLReal			Strength() { return(len(m)); };
	Void			DebugInfo();

	Vector			PointIrradiance(const Point &p, const Vector &clipNormal, Colour &clr);
		
	// fields
	Vector			m;			///< E = m P; m points to source.
	GCLReal			error;
};

#endif
